/*
  () 18.01.2009  .  (Alex-Li@Rambler.ru)
     .   AD1853  AD1955  .

         ,  BODLevel2 -  
         4,3.

*/

#include <iotiny2313.h>
#include <inavr.h>

#define AD1853
//#define AD1955

//#define AutoDetect

#define bit(n)     (1<<n)
#define Set(m,n)   (m|=bit(n))
#define Clr(m,n)   (m&=~bit(n))
#define b_CDATA    4  // PB4
#define b_CCLK     7  // PB7
#define b_LATCH    5  // PB5
#define SetCDATA   Set(PORTB,b_CDATA)
#define ClrCDATA   Clr(PORTB,b_CDATA)
#define SetLATCH   Set(PORTB,b_LATCH)
#define ClrLATCH   Clr(PORTB,b_LATCH)
#define SetCCLK    Set(PORTB,b_CCLK)
#define ClrCCLK    Clr(PORTB,b_CCLK)
#define CCLK       {SetCCLK;ClrCCLK;}
#define b_Mute     0  // PA0
#define b_Reset    1  // PA1
#define SetMute    Set(PORTA,b_Mute)
#define ClrMute    Clr(PORTA,b_Mute)
#define SetReset   Clr(PORTA,b_Reset)
#define ClrReset   Set(PORTA,b_Reset)
#define b_Freq     1 // PD1
#define b_LRCK     2 // PD2
#define SetFreq    Clr(PORTD,b_Freq)
#define ClrFreq    Set(PORTD,b_Freq)

#define Mask       0x78
#define Mask1      0x7f
#define Mask2      0x0f

#define Low44   2750
#define High44  2990
#define High48  3300
#define Low88   Low44<<1  
#define High88  High44<<1 
#define High96  High48<<1 
#define Low176  Low44<<2  
#define High176 High44<<2 
#define High192 High48<<2 


unsigned int Old=0, CNT_LRCK=0, New_LRCK;

void SPI(unsigned int Data)
{ unsigned int mask=0x8000;
  char i;
  for (i=0;i<16;i++)
  {
    if (Data & mask) SetCDATA;
    else ClrCDATA;
    CCLK;
    mask>>=1;
  }
  ClrCDATA;
}

#ifdef AD1853
void out(unsigned char Data)
{ unsigned int t=1, d;
  unsigned char x,y;
  SetMute;
  x=PIND;
  y=PINB;
  d = (Mask & x) + ((Mask & y)<<8);
#ifdef AutoDetect
  if (d & 1)
  {
    if (Data & bit(1)) Set(t,11); // PCM Sample Rate 0 (2x) 192 kHz
    if (Data & bit(0)) Set(t,10); // PCM Sample Rate 1 (4x) 96 kHz
  }
  else
#endif
  {
    if (d & bit(11)) Set(t,11); // PCM Sample Rate 0 (2x) 192 kHz
    if (d & bit(10)) Set(t,10); // PCM Sample Rate 1 (4x) 96 kHz
  }

  if (d & bit(5))    Set(t,4);  // PCM/EF Serial Data Format 0
  if (d & bit(6))    Set(t,5);  // PCM/EF Serial Data Format 1
  if (d & bit(3))    Set(t,8);  // PCM/EF Serial Data Width 0
  if (d & bit(4))    Set(t,9);  // PCM/EF Serial Data Width 1
  ClrLATCH;
  SPI(t);
  SetLATCH;
  ClrMute;
}
#endif

#ifdef AD1955
void out(unsigned int Data)
{ unsigned int t=0, d;
  unsigned char x,y;
  SetMute;
  x=PIND;
  y=PINB;
  d = (Mask1 & x) + (Mask2 & y)<<8;
#ifndef AutoDetect
  if (d & bit(0))  Set(t,12); // Data Format PCM / External DF
  if (d & bit(1))  Set(t,10); // Output Format 0
  if (d & bit(2))  Set(t,11); // Output Format 1
#else
  if (d & 1)
  {
  if (Data & bit(0)) Set(t,8); // PCM Sample Rate 0 (4x) 96 kHz
  if (Data & bit(1)) Set(t,9); // PCM Sample Rate 1 (2x) 192 kHz
  }
  else
#endif
  {
  if (d & bit(11)) Set(t,8); // PCM Sample Rate 0 (4x) 96 kHz
  if (d & bit(10)) Set(t,9); // PCM Sample Rate 1 (2x) 192 kHz
  }
  if (d & bit(3))  Set(t,2); // PCM/EF Serial Data Width 0
  if (d & bit(4))  Set(t,3); // PCM/EF Serial Data Width 1
  if (d & bit(5))  Set(t,4); // PCM/EF Serial Data Format 0
  if (d & bit(6))  Set(t,5); // PCM/EF Serial Data Format 1
  ClrLATCH;
  SPI(t);
  SetLATCH;
  t=1;
  if (Data & bit(8)) Set(t,9); // MCLK Mode 0
  if (Data & bit(9)) Set(t,10); // MCLK Mode 1
  ClrLATCH;
  SPI(t);
  SetLATCH;
  ClrMute;
}
#endif

void main( void )
{ unsigned int t;
  PORTD=0xff;
  PORTB=0x7c;
  PORTA=3;
  DDRB=0xb0;
  DDRA=3;
  DDRD=0;
  SetReset;
#ifdef AutoDetect
  DDRD=2;
  PORTD=0xfd; // change 44 freq generator
  t=PIND & 1;
  if (t)
  {
    TCNT1 = 0;
    TCCR1B= 1;
    TIMSK = bit(TOIE1);
    MCUCR = 3; // Rising edge INT0
    GIMSK = bit(INT0);
    __enable_interrupt();
  }
#endif
  for(t=0;t<10000;t++);
  ClrReset;
  for(t=0;t<10000;t++);
  out(0); // change 44 
#ifdef AutoDetect
 for(;;)
 {
  if (New_LRCK)
  {
    t = New_LRCK;
    New_LRCK = 0;
    if ((t > (Old + 2)) || (t < (Old - 2)))
    { 
      Old = t;
      if (t > Low44)
        if (t < High44)
        { // change 44 freq generator
          ClrFreq;
          out(0);
        }
        else if (t < High48)
        { // change 48 freq generator
          SetFreq;
          out(0);
        }
      else if (t > Low88)
        if (t < High88)
        { // 88
          ClrFreq;
          out(1);
        }
        else if (t < High96)
        { // 96
          SetFreq;
          out(1);
        }
      else if (t > Low176)
        if (t < High176)
        { // 176
          ClrFreq;
          out(2);
        }
        else if (t < High192)
        { // 192
          SetFreq;
          out(2);
        }
      else SetMute;
    }
  }
  MCUCR|=bit(SM1);
  __sleep();
 }
#else
 for(;;)
 {
   MCUCR|=bit(SM0);
   __sleep();
 }
#endif
}

#pragma vector=TIMER1_OVF1_vect
static __interrupt void V_timer( void )
{
 New_LRCK = CNT_LRCK;
 CNT_LRCK = 0;
}

#pragma vector=INT0_vect
static __interrupt void Int_LRCK( void )
{
 CNT_LRCK +=1;
}
